searchNodes=[{"type":"module","title":"Oidcc.Plug.ExtractAuthorization","doc":"Extract authorization request header This module should be used together with Oidcc.Plug.IntrospectToken , Oidcc.Plug.LoadUserinfo or Oidcc.Plug.ValidateJwtToken . defmodule SampleAppWeb.Endpoint do use Phoenix.Endpoint , otp_app : :sample_app # ... plug Oidcc.Plug.ExtractAuthorization plug Oidcc.Plug.IntrospectToken , [ ... ] # Check Token via Introspection plug Oidcc.Plug.LoadUserinfo , [ ... ] # Check Token via Userinfo plug Oidcc.Plug.ValidateJwtToken , [ ... ] # Check Token via JWT validation plug SampleAppWeb.Router end","ref":"Oidcc.Plug.ExtractAuthorization.html"},{"type":"type","title":"Oidcc.Plug.ExtractAuthorization.opts/0","doc":"Plug Configuration Options Options send_invalid_header_response - Customize Error Response for invalid header","ref":"Oidcc.Plug.ExtractAuthorization.html#t:opts/0"},{"type":"module","title":"Oidcc.Plug.IntrospectToken","doc":"Validate extracted authorization token using introspection. See: https://datatracker.ietf.org/doc/html/rfc7662 This module should be used together with Oidcc.Plug.ExtractAuthorization . This plug will send an introspection request for ever request. To avoid this, provide a cache to the options. defmodule SampleAppWeb.Endpoint do use Phoenix.Endpoint , otp_app : :sample_app # ... plug Oidcc.Plug.ExtractAuthorization plug Oidcc.Plug.IntrospectToken , provider : SampleApp.GoogleOpenIdConfigurationProvider , client_id : Application . compile_env! ( :sample_app , [ Oidcc.Plug.IntrospectToken , :client_id ] ) , client_secret : Application . compile_env! ( :sample_app , [ Oidcc.Plug.IntrospectToken , :client_secret ] ) plug SampleAppWeb.Router end","ref":"Oidcc.Plug.IntrospectToken.html"},{"type":"type","title":"Oidcc.Plug.IntrospectToken.opts/0","doc":"Plug Configuration Options Options provider - name of the Oidcc.ProviderConfiguration.Worker client_id - OAuth Client ID to use for the introspection client_secret - OAuth Client Secret to use for the introspection token_introspection_opts - Options to pass to the introspection send_inactive_token_response - Customize Error Response for inactive token cache - Cache token introspection","ref":"Oidcc.Plug.IntrospectToken.html#t:opts/0"},{"type":"module","title":"Oidcc.Plug.LoadUserinfo","doc":"Validate extracted authorization token using introspection. See: https://openid.net/specs/openid-connect-core-1_0.html#UserInfo This module should be used together with Oidcc.Plug.ExtractAuthorization . This plug will send a userinfo request for ever request. To avoid this, provide a cache to the options. defmodule SampleAppWeb.Endpoint do use Phoenix.Endpoint , otp_app : :sample_app # ... plug Oidcc.Plug.ExtractAuthorization plug Oidcc.Plug.LoadUserinfo , provider : SampleApp.GoogleOpenIdConfigurationProvider , client_id : Application . compile_env! ( :sample_app , [ Oidcc.Plug.LoadUserinfo , :client_id ] ) , client_secret : Application . compile_env! ( :sample_app , [ Oidcc.Plug.LoadUserinfo , :client_secret ] ) plug SampleAppWeb.Router end","ref":"Oidcc.Plug.LoadUserinfo.html"},{"type":"type","title":"Oidcc.Plug.LoadUserinfo.opts/0","doc":"Plug Configuration Options Options provider - name of the Oidcc.ProviderConfiguration.Worker client_id - OAuth Client ID to use for the introspection client_secret - OAuth Client Secret to use for the introspection userinfo_retrieve_opts - Options to pass to userinfo loading send_inactive_token_response - Customize Error Response for inactive token cache - Cache token introspection","ref":"Oidcc.Plug.LoadUserinfo.html#t:opts/0"},{"type":"module","title":"Oidcc.Plug.ValidateJwtToken","doc":"Validate extracted authorization token by validating it as a JWT token. This module should be used together with Oidcc.Plug.ExtractAuthorization . defmodule SampleAppWeb.Endpoint do use Phoenix.Endpoint , otp_app : :sample_app # ... plug Oidcc.Plug.ExtractAuthorization plug Oidcc.Plug.ValidateJwtToken , provider : SampleApp.GoogleOpenIdConfigurationProvider , client_id : Application . compile_env! ( :sample_app , [ Oidcc.Plug.ValidateJwtToken , :client_id ] ) , client_secret : Application . compile_env! ( :sample_app , [ Oidcc.Plug.ValidateJwtToken , :client_secret ] ) plug SampleAppWeb.Router end","ref":"Oidcc.Plug.ValidateJwtToken.html"},{"type":"type","title":"Oidcc.Plug.ValidateJwtToken.opts/0","doc":"Plug Configuration Options Options provider - name of the Oidcc.ProviderConfiguration.Worker client_id - OAuth Client ID to use for the introspection client_secret - OAuth Client Secret to use for the introspection send_inactive_token_response - Customize Error Response for inactive token","ref":"Oidcc.Plug.ValidateJwtToken.html#t:opts/0"},{"type":"exception","title":"Oidcc.Plug.IntrospectToken.Error","doc":"Introspection Failed Check the reason field for ther exact reason","ref":"Oidcc.Plug.IntrospectToken.Error.html"},{"type":"exception","title":"Oidcc.Plug.LoadUserinfo.Error","doc":"Retrieve Userinfo Failed Check the reason field for ther exact reason","ref":"Oidcc.Plug.LoadUserinfo.Error.html"},{"type":"exception","title":"Oidcc.Plug.ValidateJwtToken.Error","doc":"Validation Failed Check the reason field for ther exact reason","ref":"Oidcc.Plug.ValidateJwtToken.Error.html"},{"type":"extras","title":"Oidcc.Plug","doc":"Plug Integration for oidcc library.","ref":"readme.html"},{"type":"extras","title":"Oidcc.Plug - Installation","doc":"The package can be installed by adding oidcc_plug to your list of dependencies in mix.exs : def deps do [ { :oidcc_plug , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation"},{"type":"extras","title":"Oidcc.Plug - Usage","doc":"defmodule SampleApp.Application do # ... @impl true def start ( _type , _args ) do children = [ # ... { Oidcc.ProviderConfiguration.Worker , %{ issuer : &quot;https://accounts.google.com/&quot; , name : SampleApp.GoogleOpenIdConfigurationProvider } } , # Start the Endpoint (http/https) SampleAppWeb.Endpoint ] # See https://hexdocs.pm/elixir/Supervisor.html # for other strategies and supported options opts = [ strategy : :one_for_one , name : SampleApp.Supervisor ] Supervisor . start_link ( children , opts ) end # ... end defmodule SampleAppWeb.Endpoint do use Phoenix.Endpoint , otp_app : :sample_app # ... plug Oidcc.Plug.ExtractAuthorization @client_id Application . compile_env! ( :sample_app , [ :openid_credentials , :client_id ] ) @client_secret Application . compile_env! ( :sample_app , [ :openid_credentials , :client_secret ] ) # Check Token via Introspection plug Oidcc.Plug.IntrospectToken , provider : SampleApp.GoogleOpenIdConfigurationProvider , client_id : @client_id , client_secret : @client_secret # OR: Check Token via Userinfo plug Oidcc.Plug.LoadUserinfo , provider : SampleApp.GoogleOpenIdConfigurationProvider , client_id : @client_id , client_secret : @client_secret # OR: Check Token via JWT validation plug Oidcc.Plug.ValidateJwtToken , provider : SampleApp.GoogleOpenIdConfigurationProvider , client_id : @client_id , client_secret : @client_secret plug SampleAppWeb.Router end","ref":"readme.html#usage"}]